
//+------------------------------------------------------------------+
//|                                                          SOK.mq4 |
//+------------------------------------------------------------------+

#property indicator_separate_window
 
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

extern datetime   some_time   = D'2010.01.01 12:00';
extern string     pair1       = "GBPUSD";
extern color      color_pair1 = Red;
extern string     pair2       = "EURUSD";
extern color      color_pair2 = Blue;

#property indicator_level1 3.5
#property indicator_level2 3
#property indicator_level3 2.500
#property indicator_level4 2
#property indicator_level5 1.5
#property indicator_level6 1
#property indicator_level7 0.5
#property indicator_level8 0

extern string  pop_Len  = "Nastavim si kolko sviecok potam";
extern int     Length   = 1000;
extern double  nasobek  = 0;  //ak nastavim 0 -> ind sam spocita nasobitel pomocou Max_Level, inak plati nastavena hodnota
extern double  Max_Level = 4;

int digitsPair1, digitsPair2;
double Max_L = 0;
string indname;
double nasobitel;

double Level1[];
double Level2[];
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

//velikost pozice je jasna tam si nastavis velikost u te vjetsi pozice ta se priradi tomu paru co ma nissi hodnotu a vypocet te druhe je delenec mezi tou vissi cenou a tou nissi to je GBPUSD 1,5985 a EURUSD 1,3684
//[20:36:35] donny65: 1,5985/1,3684=1,1681
//[20:38:09] donny65: a tim se vydeli ta vetsi pozice to je ze si nastavys  treba 2,40 lotu ta bude u EURUSD  a GBPUSD bude 2,05 lotu


int init()
{
//---- indicators
   if (nasobek > 0)
      nasobitel = nasobek;

   indname = "SOK ";
   IndicatorShortName(indname);
   
   digitsPair1=MarketInfo(pair1,MODE_DIGITS);
   digitsPair2=MarketInfo(pair2,MODE_DIGITS);

   SetIndexStyle(0, DRAW_LINE,EMPTY,EMPTY,color_pair1);
   SetIndexBuffer(0, Level1);
   SetIndexStyle(1, DRAW_LINE,EMPTY,EMPTY,color_pair2);
   SetIndexBuffer(1, Level2);

//----
   return(0);
}
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
   ObjectDelete("popisPar1"+indname);
   ObjectDelete("popisPar2"+indname);

//----
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int WindowNumber = WindowFind(indname);
   
   //Print("dksad "+WindowNumber + " fff " +indname);
   
   if(ObjectFind("popisPar1"+indname)==-1) 
   {
      ObjectCreate ("popisPar1" + indname, OBJ_LABEL, WindowNumber, 0, 0);
      ObjectSetText ("popisPar1" + indname, pair1 + "[" + digitsPair1 + "]", 9, "Arial Bold", color_pair1);
      ObjectSet ("popisPar1" + indname, OBJPROP_CORNER, 0);
      ObjectSet ("popisPar1" + indname, OBJPROP_XDISTANCE, 60);
      ObjectSet ("popisPar1" + indname, OBJPROP_YDISTANCE, 2);
   }
   else
   {
      ObjectSetText ("popisPar1" + indname, pair1, 9, "Arial Bold", color_pair1);
   }
   
  
   if(ObjectFind ("popisPar2" + indname) == -1) 
   {
      ObjectCreate ("popisPar2" + indname, OBJ_LABEL, WindowNumber, 0, 0);
      ObjectSetText ("popisPar2" + indname, pair2 + "[" + digitsPair2 + "]", 9, "Arial Bold", color_pair2);
      ObjectSet ("popisPar2" + indname, OBJPROP_CORNER, 0);
      ObjectSet ("popisPar2" + indname, OBJPROP_XDISTANCE, 140);
      ObjectSet ("popisPar2" + indname, OBJPROP_YDISTANCE, 2);
   }
   else
   {
      ObjectSetText ("popisPar2" + indname, pair2, 9, "Arial Bold", color_pair2);
   }
   
   int i, limit, counted_bars = IndicatorCounted();
   
   double  Par_1_Close, Par_2_Close, Par_1_Open, Par_2_Open, Par_1_Start, Par_2_Start;
   double  a1, a2, c1, c2;

//----
   if(counted_bars < 0) 
      return(-1);
   if(counted_bars > 0) 
      counted_bars--;
   
   limit = Bars - counted_bars;
   
   if(Length > 0) 
      limit = Length;

   for (i = limit; i>0; i--)
   {
      double delitel = 100;
        
      int posun1=iBarShift(pair1,PERIOD_M1,some_time);
      int posun2=iBarShift(pair2,PERIOD_M1,some_time);
        
      
       
       
         Par_1_Close = iClose(pair1,0,i);
          
     
         Par_2_Close = iClose(pair2,0,i)/delitel;
     
         Par_2_Close = iClose(pair2,0,i);
          
    
         Par_1_Open = iOpen(pair1,0,i)/delitel;
     
         Par_1_Open = iOpen(pair1,0,i);
          
      
         Par_2_Open = iOpen(pair2,0,i)/delitel;
      
         Par_2_Open = iOpen(pair2,0,i);
        
      Par_1_Start = iOpen(pair1,PERIOD_M1,posun1);

      Par_2_Start = iOpen(pair2,PERIOD_M1,posun2);
  
      a1 = MarketInfo (pair1, MODE_TICKVALUE);
      a2 = MarketInfo (pair2, MODE_TICKVALUE);

      c1 = Par_1_Start + Par_1_Close;
      c2 = Par_2_Start + Par_2_Close;

      Level1[i] = (((c2 * a2) * Par_1_Close) - (c1 * a1) * Par_2_Close);
      Level2[i] = (((c1 * a1) * Par_2_Close) - (c2 * a2) * Par_1_Close);
      Max_L = MathMax(Max_L,Level1[i]);
   }
   
   if (nasobek > 0)
      nasobitel = nasobek;
   else
   {
      if (Max_L > 0)
         nasobitel = NormalizeDouble((Max_Level/Max_L),1);
   }
   
   for (i = limit; i>0; i--)
   { 
      Level1[i] = Level1[i] * nasobitel;
      Level2[i] = Level2[i] * nasobitel;
   }
//----
   return(0);
}